



#include <iML3.mqh> 

#property indicator_chart_window 

#property indicator_color1 Blue
#property indicator_color2 Red
 
#property indicator_color3 Yellow
#property indicator_color4 Yellow

#property indicator_color5 Yellow
#property indicator_color6 Yellow

#property indicator_color7 Magenta
#property indicator_color8 SlateBlue

#property indicator_buffers 6

double hmed[]; //   --  
double lmed[]; //   --  1 
 
double ocu[]; //    --  2
double ocd[]; //   --  3

double slcu[]; //   --  4
double slcd[]; //   --  5


extern int Size=240; //  
extern int Step=1;  //    

extern int IndicatorStart=0;//288000; //       
extern double OChanelKCorr=0.0;       //  (  -  ) 
extern double OLucky=0.2;             //    
extern int OAve=4;                    //           
extern int EOChanel=0;  // (1)     

extern double SLChanelKCorr=0.0; //    ( - )  0 --   
extern double SLLucky=0.05;         //     
extern int SLAve=0;                 // This not use, use only OAve 
extern int ESLChanel=0; //     


extern int BackDelta0=0; //     
extern int BackDelta1=5; //     

extern double WayBackDeltaDeviation=0.3;    //          
extern double ChangeBackDeltaDeviation=0.1;

extern int ProfitParam=10; //  
extern int OpenParam=55;
extern int CloseParam=25;
extern int StatParam=0; 
extern int NParam=5;
      
extern int Loop=1;//  
extern bool UseAsExpertAssist=false; //        
extern bool SetGlobalVars=false; //       
extern string GVarPrefix=""; //    
extern int ShowDialog=0; // 

extern double KVStep=1.; //3.6;
extern string StrIndicatorStart="2008.04.21 04:00"; //     

int h=0;

double rates[][6];

string s="";
string _GVarPrefix="";

string TrimDouble ( double var )
{
   string r=DoubleToStr( var, 8 );
   
   int l=StringLen(r)-1;
   int c;
   int i;
   
   for( i=l;i>=0;i--){
      c=StringGetChar(r,i);
      if ( c != '0' && c != '.' ){
         return ( StringSubstr(r,0,i+1) );
      }
   }   
   return ( "0" );
}
#include <iML3api.mqh>
int init2()
{

   if ( UseAsExpertAssist ){ //        
   
      _GVarPrefix=GVarPrefix;//    
      Size           = idata (GVarPrefix, "Size", Size, true );   //    
      Step           = idata (GVarPrefix, "Step", Step, true  );  //      
      
      IndicatorStart = Bars-idata (GVarPrefix, "IndicatorStart",IndicatorStart, true  );//   ,  
      //   
      OChanelKCorr   = idata (GVarPrefix, "OChanelKCorr",OChanelKCorr, true  ); //   ,        0  1
      OLucky         = idata (GVarPrefix, "OLucky",OLucky , true ); //      
      OAve           = idata (GVarPrefix, "OAve",OAve , true ); //   
      EOChanel       = idata (GVarPrefix, "EOChanel",EOChanel , true ); // 1       0  
      
      SLChanelKCorr  = idata (GVarPrefix, "SLChanelKCorr",SLChanelKCorr , true );
      SLLucky        = idata (GVarPrefix, "SLLucky",SLLucky , true );
      SLAve          = idata (GVarPrefix, "SLAve", SLAve, true );
      ESLChanel      = idata (GVarPrefix, "ESLChanel", ESLChanel, true );
      
      Loop           = idata (GVarPrefix, "Loop",Loop , true );
    
      BackDelta0     = idata (GVarPrefix, "BackDelta0",BackDelta0 , true );
      BackDelta1     = idata (GVarPrefix, "BackDelta1",BackDelta1 , true );
      WayBackDeltaDeviation = idata (GVarPrefix, "WayBackDeltaDeviation",WayBackDeltaDeviation , true );
      ChangeBackDeltaDeviation = idata (GVarPrefix, "ChangeBackDeltaDeviation",ChangeBackDeltaDeviation , true );
      
      OpenParam      = idata (GVarPrefix, "OpenParam", OpenParam, true );
      CloseParam     = idata (GVarPrefix, "CloseParam", CloseParam, true );
      ProfitParam    = idata (GVarPrefix, "ProfitParam", ProfitParam, true );
      NParam         = idata (GVarPrefix, "NParam", NParam, true );
      
      StatParam      = idata (GVarPrefix, "StatParam", StatParam, true );
      KVStep         = idata (GVarPrefix, "KVStep", KVStep, true );
      
      
      Print(GVarPrefix,"--","BackDelta0=",BackDelta0);
      Print(GVarPrefix,"--","BackDelta1=",BackDelta1);
      Print(GVarPrefix,"--","WayBackDeltaDeviation=",WayBackDeltaDeviation);
      Print(GVarPrefix,"--","ChangeBackDeltaDeviation=",ChangeBackDeltaDeviation);
   }
   else {//        
      if ( GVarPrefix != "" ) //        
         _GVarPrefix=GVarPrefix;
      else
         _GVarPrefix="iML3"+"("+
                           Size+","+
                           Step+","+
                           IndicatorStart+","+
                           TrimDouble(OChanelKCorr)+","+
                           TrimDouble(OLucky)+","+
                           OAve+","+
                           EOChanel+","+
                           TrimDouble(SLChanelKCorr)+","+
                           TrimDouble(SLLucky)+","+
                           SLAve+","+
                           ESLChanel+","+
                           Loop+")";
   }
   Print(GVarPrefix,"--","IndicatorStart=",IndicatorStart); // 
   Print(GVarPrefix,"--","prefix:",_GVarPrefix);
   
   s="("+Size+","+OLucky+","+SLLucky+")";      
   IndicatorShortName (WindowExpertName()+ s );
   
   ArrayCopyRates(rates);
   
   h=iML3Init ( rates, Bars , Point, MarketInfo(Symbol(), MODE_MINLOT),Size, Step, MarketInfo(Symbol(), MODE_SPREAD),
                         
                         
                         OChanelKCorr, 
                         OLucky, 
                         OAve,
                         EOChanel,
                         
                         SLChanelKCorr,
                         SLLucky,
                         SLAve,// This not use, use only OAve 
                         ESLChanel,
                         
                         BackDelta1,
                         BackDelta0,
                         WayBackDeltaDeviation,  
                         ChangeBackDeltaDeviation,                        
                         
                         Period(), 
                         Loop , ShowDialog, 0 , 0, KVStep);
   
   
   
   
}

int init()
{

   IndicatorBuffers(6);//  6
   
   SetIndexStyle  ( 0, DRAW_LINE );
   SetIndexBuffer ( 0, hmed );
   SetIndexEmptyValue ( 0,0);
   SetIndexLabel  ( 0,WindowExpertName()+".hmed"+s);//      
   
   SetIndexStyle  ( 1, DRAW_LINE );
   SetIndexBuffer ( 1, lmed );
   SetIndexEmptyValue ( 1,0);
   SetIndexLabel  ( 1,WindowExpertName()+".lmed"+s);
   
   SetIndexStyle  ( 2, DRAW_LINE );
   SetIndexBuffer ( 2, ocu );
   SetIndexEmptyValue ( 2,0);
   SetIndexLabel  ( 2,WindowExpertName()+".ocu"+s);

   SetIndexStyle  ( 3, DRAW_LINE );
   SetIndexBuffer ( 3, ocd );
   SetIndexEmptyValue ( 3,0);
   SetIndexLabel  ( 3,WindowExpertName()+".ocd"+s);   
   
   SetIndexStyle  ( 4, DRAW_LINE );
   SetIndexBuffer ( 4, slcu );
   SetIndexEmptyValue ( 4,0);
   SetIndexLabel  ( 4, WindowExpertName()+".slcu"+s);

   SetIndexStyle  ( 5, DRAW_LINE );
   SetIndexBuffer ( 5, slcd );
   SetIndexEmptyValue ( 5,0);
   SetIndexLabel  ( 5,WindowExpertName()+".slcd"+s);   

  
   if ( StrIndicatorStart != "" ){//    
      
      datetime d;
      
      if ( StringGetChar ( StrIndicatorStart, 0 ) == '-' ){
         d=SpecGetDate ( StrIndicatorStart );   
        // Print("D:==",TimeToStr(d));
      }
      else
         d=StrToTime(StrIndicatorStart); //      
     
      if ( d != 0  ){
         IndicatorStart=Bars-iBarShift(0,0,d);
         Print(GVarPrefix," -- IndicatorStart:",TimeToStr(Time[Bars-IndicatorStart],TIME_DATE|TIME_SECONDS));
      }
      else
         Print(GVarPrefix," -- StrIndicatorStart not NULL but IndicatorStart:",IndicatorStart);  
      
   }
   
   
   
   return(0);
}

int deinit()
{
   iML3DeInit(h);
   
   int l=StringLen(_GVarPrefix);
   if ( l == 0 )
      return;
      
   string name;
   string pr;
   int    last=ObjectsTotal()-1;
   
   for ( int i=last; i>=0; i-- ){
      name = ObjectName(i);
      pr=StringSubstr(name,0,l);
   //   Print ( "pr:", pr,",name:",name,",ppp:",_GVarPrefix );
      if ( pr == _GVarPrefix )
         ObjectDelete(name);
    }
    
   GlobalVariablesDeleteAll( _GVarPrefix );

   return(0);
}

//  

void DriveChanelDeviation ( double arr[], int p1, int p0, double _waydev, double _changedev, string on, color cl,  int style, bool ray, bool debug )
{
   int    l    = (p1-p0)+1;
   double dlt  = arr[p0] - arr[p1];
   
   if ( dlt == 0 )
      return;
      
   double updev;
   double downdev;
   
   
   if ( dlt > 0 ){	
		updev    =  MathAbs(dlt*_waydev); // 
		downdev  =  MathAbs(dlt*_changedev ); // 

	}
	else { 
		updev    =  MathAbs(dlt*_changedev); // 
		downdev  =  MathAbs(dlt*_waydev); // 

	}
      
   if ( debug ){   
      TrandLine ( _GVarPrefix+on+"+", "", Time[p0], arr[p0]+updev, Time[p1], arr[p1]+updev, cl, style, 1, false, true );
      TrandLine ( _GVarPrefix+on+"-", "", Time[p0], arr[p0]-downdev ,Time[p1], arr[p1]-downdev , cl, style, 1, false, true );
   }
    TrandLine ( _GVarPrefix+on, "", Time[p0], arr[p0] ,Time[p1], arr[p1], cl, style, 1, ray, true );
}

#include <Lines.mqh>

int start()
{
 
   static bool NoInited = true;
   
   
   
   if ( UseAsExpertAssist ){ //        
      if ( idata( GVarPrefix,"Start",0, true ) == 0 ){
         Print(GVarPrefix,"--","Wait start :",GVarPrefix );
         return;
      }   
   }   
      
   int StartCalc;
   int _IndicatorCounted=IndicatorCounted();
   
   if ( NoInited ){
      Print(GVarPrefix,"--","Init:",Bars);
      NoInited=false;
      init2();
      _IndicatorCounted=0;
   }
   
   
   
   if ( IndicatorStart > _IndicatorCounted )
      StartCalc=IndicatorStart; 
   else
      StartCalc=_IndicatorCounted   ;
   
   double klsell;
   double klbuy;
  
   
   ArrayCopyRates(rates) ;
   iML3Start ( h, rates, Bars );   
   
   
  
   int ret=iML3Calc   ( h, hmed, lmed, StartCalc,  Bars  );//  
  /* 
   if ( (Bars-1) - StartCalc <= 0 ){
      if ( ret != 0 )
         Print("  (",(Bars-1) - StartCalc,"), ");
      else
         Print("  (",(Bars-1) - StartCalc,"),  ");   
   }
   */
   
   iML3Chanel ( h, hmed,lmed , ocu,    ocd, slcu,    slcd,  StartCalc, Bars );//  

   DriveChanelDeviation(hmed,BackDelta0,BackDelta1,WayBackDeltaDeviation,ChangeBackDeltaDeviation,".hmed",Blue,STYLE_DASH,true, false );
   DriveChanelDeviation(lmed,BackDelta0,BackDelta1,WayBackDeltaDeviation,ChangeBackDeltaDeviation,".lmed",Red,STYLE_DASH,true, false);
   
   if ( SetGlobalVars ){
   
      klsell = iML3_KLSELL(h);
      klbuy  = iML3_KLBUY(h);

      static datetime KLTime=0;

      if ( StatParam != 0 && ( klbuy == 0 || klsell == 0 || Time[0] > KLTime ) ){
         iML3_KL ( h, hmed,lmed, Bars- StatParam*PERIOD_D1, Bars, OpenParam, CloseParam, ProfitParam, NParam);
         KLTime = Time[0] + (1439*60-(Time[0]%(1440*60))) + (1435*60);
         Print(GVarPrefix,"--","Current time:",TimeToStr(Time[0],TIME_DATE|TIME_MINUTES|TIME_SECONDS ),",Next time:",TimeToStr(KLTime,TIME_DATE|TIME_MINUTES|TIME_SECONDS ));
      }
   
      

      GlobalVariableSet( _GVarPrefix+".hmed.B0",            hmed[BackDelta0] ); //        0
      GlobalVariableSet( _GVarPrefix+".hmed.B1",            hmed[BackDelta1] ); //        1

      GlobalVariableSet( _GVarPrefix+".lmed.B0",            lmed[BackDelta0] ); // -     
      GlobalVariableSet( _GVarPrefix+".lmed.B1",            lmed[BackDelta1] );


     
   //    ,      1    . 
   //       .       
   //        !!!!
   

      GlobalVariableSet( _GVarPrefix+".hmed.trandp",        iML3TrandPower ( h, hmed, 0, 0 )  ); // 
      GlobalVariableSet( _GVarPrefix+".lmed.trandp",        iML3TrandPower ( h, lmed, 1, 0 )  );
      GlobalVariableSet( _GVarPrefix+".hmed.flatp",         iML3FlatPower ( h, hmed, 0, 0 )  );
      GlobalVariableSet( _GVarPrefix+".lmed.flatp",         iML3FlatPower ( h, lmed, 1, 0 )  );
   
   //   
   
      GlobalVariableSet( _GVarPrefix+".KlSell",             iML3_KLSELL(h) );
      GlobalVariableSet( _GVarPrefix+".KlBuy",              iML3_KLBUY(h) );
   //  
      GlobalVariableSet( _GVarPrefix+".SellMaxDrawDown",    iML3_SellMaxDrawDown(h) );
      GlobalVariableSet( _GVarPrefix+".BuyMaxDrawDown",     iML3_BuyMaxDrawDown(h) );
   

   //   TrandD     PTrandD
   //        
   //          -  
   //        
    
   
      int hdur,hpdur; //    
      int ldur,lpdur; //    
                                                hdur=      iML3TrandDuration(h,hmed, 0);
      GlobalVariableSet( _GVarPrefix+".hmed.trandd",      hdur );
                                                hpdur=     iML3TrandDuration(h,hmed, hdur);
      GlobalVariableSet( _GVarPrefix+".hmed.ptrandd",      hpdur   );
                                                ldur=      iML3TrandDuration(h,lmed, 0);
      GlobalVariableSet( _GVarPrefix+".lmed.trandd",      ldur );      
                                                lpdur=     iML3TrandDuration ( h, lmed, ldur );
      GlobalVariableSet( _GVarPrefix+".lmed.ptrandd",     lpdur    );
      
      int dur=MathMax(hdur,ldur);
      int pdur=MathMax(hpdur,lpdur);
      
      iML3Fractals   ( h, hmed, lmed, dur, 0 );
      
      int imax=iML3iMax ( h );
      int imin=iML3iMin ( h );
      
      
  //    VLine ( _GVarPrefix+".dur",  "", Time[dur],  DarkSlateGray, STYLE_DOT, 1, true );
  //    VLine ( _GVarPrefix+".pdur", "", Time[pdur], DarkSlateGray, STYLE_DOT, 1, true );
      
      VLine ( _GVarPrefix+".imax", "", Time[imax], DarkSlateGray, STYLE_DOT, 1 , true);
      VLine ( _GVarPrefix+".imin", "", Time[imin], DarkSlateGray, STYLE_DOT, 1 , true);
      
      double  mmax,mmin;
      int    t = 60*(BackDelta1-BackDelta0)*Period();
      
      mmax = ( hmed[imax]+lmed[imax] ) / 2;
      double sizemax= High[imax]-mmax;
      
  //    Rectangle ( _GVarPrefix+".rimax","", Time[imax]-t/2, mmax-sizemax, Time[imax] + t/2, High[imax],  Gray,  STYLE_DASH, 1, false );
      
      mmin = ( hmed[imin]+lmed[imin] ) / 2;
      double sizemin = mmin-Low[imin];
  //    Rectangle ( _GVarPrefix+".rimin","", Time[imin]-t/2, mmin+sizemin,  Time[imin] + t/2, Low[imin],  Gray,  STYLE_DASH, 1, false );
      
      double size=MathMax(sizemin,sizemax);
      
      
      if ( imax < imin ){
         TrandLine ( _GVarPrefix+".medline",  "", Time[imin], mmin, Time[imax], mmax, DarkSlateGray,  STYLE_DOT, 1, true, true );
         TrandLine ( _GVarPrefix+".highline", "", Time[imin], mmin+size, Time[imax], mmax+size, DarkSlateGray,  STYLE_DOT, 1, true , true);
         TrandLine ( _GVarPrefix+".lowline",  "", Time[imin], mmin-size, Time[imax], mmax-size, DarkSlateGray,  STYLE_DOT, 1, true , true);
      }
      else{
         TrandLine (  _GVarPrefix+".medline",  "", Time[imax], mmax, Time[imin], mmin, DarkSlateGray,  STYLE_DOT, 1, true , true);
         TrandLine (  _GVarPrefix+".highline", "", Time[imax], mmax+size, Time[imin], mmin+size, DarkSlateGray,  STYLE_DOT, 1, true, true );
         TrandLine (  _GVarPrefix+".lowline", "", Time[imax], mmax-size, Time[imin], mmin-size, DarkSlateGray,  STYLE_DOT, 1, true, true );
         
      }
      
   //               
      GlobalVariableSet( _GVarPrefix+".lmed.ChangePoint",   iML3ChangePointL(h) );
      GlobalVariableSet( _GVarPrefix+".hmed.ChangePoint",   iML3ChangePointH(h)  );  
      
      GlobalVariableSet( _GVarPrefix+".hmed.trand",         iML3Trand ( h, hmed, 0 )  );
      GlobalVariableSet( _GVarPrefix+".lmed.trand",         iML3Trand ( h, lmed, 0 )  );
      
      GlobalVariableSet( _GVarPrefix+".hmed",               hmed[0] );
      GlobalVariableSet( _GVarPrefix+".lmed",               lmed[0] );
   
      GlobalVariableSet( _GVarPrefix+".ocu",                ocu[0] );
      GlobalVariableSet( _GVarPrefix+".ocd",                ocd[0] );
   
      GlobalVariableSet( _GVarPrefix+".slcu",               slcu[0] );
      GlobalVariableSet( _GVarPrefix+".slcd",               slcd[0] );
   
   }   
   
}

//       ... 